## qutim 0.1

=== Makefile ===
#############################################################################
# Makefile for building: qutIM
# Generated by qmake (2.01a) (Qt 4.4.0) on: Wed Jun 11 12:11:04 2008
# Project:  qutIM.pro
# Template: app
# Command: /usr/bin/qmake -unix CONFIG+=debug_and_release -o Makefile qutIM.pro
#############################################################################

first: release
install: release-install
uninstall: release-uninstall
MAKEFILE      = Makefile
QMAKE         = /usr/bin/qmake
DEL_FILE      = rm -f
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir -p
COPY          = cp -f
COPY_FILE     = $(COPY)
COPY_DIR      = $(COPY) -r
INSTALL_FILE  = install -m 644 -p
INSTALL_PROGRAM = install -m 755 -p
INSTALL_DIR   = $(COPY_DIR)
DEL_FILE      = rm -f
SYMLINK       = ln -sf
DEL_DIR       = rmdir
MOVE          = mv -f
CHK_DIR_EXISTS= test -d
MKDIR         = mkdir -p
SUBTARGETS    =  \
		release \
		debug

release: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release
release-make_default: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release 
release-make_first: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release first
release-all: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release all
release-clean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release clean
release-distclean: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release distclean
release-install: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release install
release-uninstall: $(MAKEFILE).Release FORCE
	$(MAKE) -f $(MAKEFILE).Release uninstall
debug: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug
debug-make_default: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug 
debug-make_first: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug first
debug-all: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug all
debug-clean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug clean
debug-distclean: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug distclean
debug-install: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug install
debug-uninstall: $(MAKEFILE).Debug FORCE
	$(MAKE) -f $(MAKEFILE).Debug uninstall

Makefile: qutIM.pro  /usr/share/qt4/mkspecs/linux-g++/qmake.conf /usr/share/qt4/mkspecs/common/g++.conf \
		/usr/share/qt4/mkspecs/common/unix.conf \
		/usr/share/qt4/mkspecs/common/linux.conf \
		/usr/share/qt4/mkspecs/qconfig.pri \
		/usr/share/qt4/mkspecs/features/qt_functions.prf \
		/usr/share/qt4/mkspecs/features/qt_config.prf \
		/usr/share/qt4/mkspecs/features/exclusive_builds.prf \
		/usr/share/qt4/mkspecs/features/default_pre.prf \
		/usr/share/qt4/mkspecs/features/release.prf \
		/usr/share/qt4/mkspecs/features/debug_and_release.prf \
		/usr/share/qt4/mkspecs/features/default_post.prf \
		/usr/share/qt4/mkspecs/features/warn_on.prf \
		/usr/share/qt4/mkspecs/features/qt.prf \
		/usr/share/qt4/mkspecs/features/unix/thread.prf \
		/usr/share/qt4/mkspecs/features/moc.prf \
		/usr/share/qt4/mkspecs/features/resources.prf \
		/usr/share/qt4/mkspecs/features/uic.prf \
		/usr/share/qt4/mkspecs/features/yacc.prf \
		/usr/share/qt4/mkspecs/features/lex.prf \
		/usr/lib/qt4/libQtXml.prl \
		/usr/lib/qt4/libQtCore.prl \
		/usr/lib/qt4/libQtGui.prl \
		/usr/lib/qt4/libQtNetwork.prl
	$(QMAKE) -unix CONFIG+=debug_and_release -o Makefile qutIM.pro
/usr/share/qt4/mkspecs/common/g++.conf:
/usr/share/qt4/mkspecs/common/unix.conf:
/usr/share/qt4/mkspecs/common/linux.conf:
/usr/share/qt4/mkspecs/qconfig.pri:
/usr/share/qt4/mkspecs/features/qt_functions.prf:
/usr/share/qt4/mkspecs/features/qt_config.prf:
/usr/share/qt4/mkspecs/features/exclusive_builds.prf:
/usr/share/qt4/mkspecs/features/default_pre.prf:
/usr/share/qt4/mkspecs/features/release.prf:
/usr/share/qt4/mkspecs/features/debug_and_release.prf:
/usr/share/qt4/mkspecs/features/default_post.prf:
/usr/share/qt4/mkspecs/features/warn_on.prf:
/usr/share/qt4/mkspecs/features/qt.prf:
/usr/share/qt4/mkspecs/features/unix/thread.prf:
/usr/share/qt4/mkspecs/features/moc.prf:
/usr/share/qt4/mkspecs/features/resources.prf:
/usr/share/qt4/mkspecs/features/uic.prf:
/usr/share/qt4/mkspecs/features/yacc.prf:
/usr/share/qt4/mkspecs/features/lex.prf:
/usr/lib/qt4/libQtXml.prl:
/usr/lib/qt4/libQtCore.prl:
/usr/lib/qt4/libQtGui.prl:
/usr/lib/qt4/libQtNetwork.prl:
qmake: qmake_all FORCE
	@$(QMAKE) -unix CONFIG+=debug_and_release -o Makefile qutIM.pro

qmake_all: FORCE

make_default: release-make_default debug-make_default FORCE
make_first: release-make_first debug-make_first FORCE
all: release-all debug-all FORCE
clean: release-clean debug-clean FORCE
distclean: release-distclean debug-distclean FORCE
	-$(DEL_FILE) Makefile

release-mocclean: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocclean
debug-mocclean: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocclean
mocclean: release-mocclean debug-mocclean

release-mocables: $(MAKEFILE).Release
	$(MAKE) -f $(MAKEFILE).Release mocables
debug-mocables: $(MAKEFILE).Debug
	$(MAKE) -f $(MAKEFILE).Debug mocables
mocables: release-mocables debug-mocables
FORCE:

$(MAKEFILE).Release: Makefile
$(MAKEFILE).Debug: Makefile

## qutim 0.2.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.6 FATAL_ERROR)
IF (COMMAND cmake_policy)
	cmake_policy (SET CMP0003 NEW)
ENDIF (COMMAND cmake_policy)
PROJECT (qutim)
SET(QT_MIN_VERSION "4.4.0") 

ADD_DEFINITIONS ( -DBUILD_QUTIM )

if( UNIX )
	if( BSD )
		SET( CMAKE_THREAD_LIBS -pthread )
		SET( CMAKE_USE_PTHREADS ON )
		SET( CMAKE_EXE_LINKER_FLAGS -pthread )
	endif( BSD )
endif( UNIX )

if(NOT REVISION ) 
    find_path(REVISION_ENTRY "entries" "${CMAKE_CURRENT_SOURCE_DIR}/.svn")
    if( REVISION_ENTRY )
	file(STRINGS "${REVISION_ENTRY}/entries"
	    QUTIM_SVN_INFO
	    LIMIT_COUNT 4)
	list(GET QUTIM_SVN_INFO 3 QUTIM_SVN_REVISION)
    else( REVISION_ENTRY )
	find_path(REVISION_FILE ".revision" "${CMAKE_CURRENT_SOURCE_DIR}")
	if( REVISION_FILE )
	    file(STRINGS "${REVISION_FILE}/.revision"
		QUTIM_SVN_INFO
		LIMIT_COUNT 2)
	    list(GET QUTIM_SVN_INFO 0 QUTIM_SVN_REVISION)
	else( REVISION_FILE )
	    set( QUTIM_SVN_REVISION 0 )
	endif( REVISION_FILE )
    endif( REVISION_ENTRY )
else(NOT REVISION )
    set( QUTIM_SVN_REVISION ${REVISION} )
endif(NOT REVISION )

message( "Current revision: ${QUTIM_SVN_REVISION}" )

ADD_DEFINITIONS( -DQUTIM_SVN_REVISION=${QUTIM_SVN_REVISION} )



SET (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
SET (CMAKE_BUILD_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
SET (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
LIST (APPEND CMAKE_MODULE_PATH "cmake")
LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
SET (QT_USE_QTNETWORK true)
SET (QT_USE_QTXML true)
IF(NOT NO_CHAT)
	SET (QT_USE_QTWEBKIT true)
	SET (QT_USE_QTUITOOLS true)
ENDIF(NOT NO_CHAT)
SET (QUTIM_LIBS "")

IF( Phonon )
	SET (PHONON_REQUIRED)
	include( FindPhonon )
	IF(PHONON_FOUND)
		ADD_DEFINITIONS ( -DHAVE_PHONON )
		LIST(APPEND QUTIM_LIBS ${PHONON_LIBS})
	ENDIF(PHONON_FOUND)
ENDIF( Phonon )

SET (QUTIM_PLUGINS_DEST "lib/qutim/")
FIND_PACKAGE (Qt4 REQUIRED)

INCLUDE (UseQt4)
INCLUDE (MacroEnsureVersion)
INCLUDE_DIRECTORIES (${QT_QTGUI_INCLUDE_DIR}
	${QT_QTCORE_INCLUDE_DIR}
	${QT_QTXML_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	.
		src
		src/3rdparty/qtsolutions
		src/plugins
		src/idle
		include
	)

macro_ensure_version( "4.5.0" ${QTVERSION} Qt4_HAS_4_5 )

IF (UNIX)
	include( FindPkgConfig )
	pkg_check_modules (XSS xscrnsaver)
	IF( XSS_FOUND )
		ADD_DEFINITIONS( -DHAVE_XSS )
		FIND_LIBRARY( XSS_LIB NAMES Xss PATHS ${XSS_LIBDIR} )
		LIST( APPEND QUTIM_LIBS ${XSS_LIB} )
		INCLUDE_DIRECTORIES( ${XSS_INCLUDEDIR} )
	ELSE( XSS_FOUND )
		message(STATUS "Warning: libxss not found, idle detection won't be accurate")
	ENDIF( XSS_FOUND )
ENDIF (UNIX)

SET (HEADERS
	include/qutim/plugininterface.h
	include/qutim/protocolinterface.h
	solutions/qtcustomwidget.h
	solutions/qtcustomwidget_p.h
	src/3rdparty/qtsolutions/qtlocalpeer.h
	src/3rdparty/qtwin/qtwin.h
	src/aboutinfo.h
	src/abstractcontextlayer.h
	src/abstractlayer.h
	src/accountmanagement.h
	src/addaccountwizard.h
	src/console.h
	src/globalsettings/abstractglobalsettings.h
	src/globalsettings/globalproxysettings.h
	src/guisettingswindow.h
	src/iconmanager.h
	src/idle/idle.h
	src/logindialog.h
	src/mainsettings.h
	src/pluginsettings.h
	src/pluginsystem.h
	src/profilelogindialog.h
	src/qutim.h
	src/qutimsettings.h
	src/systeminfo.h
	)
if( Qt4_HAS_4_5 )
	LIST( APPEND HEADERS src/proxyfactory.h ) 
endif( Qt4_HAS_4_5 )

SET (SOURCES
	main.cpp
	solutions/qtcustomwidget.cpp
	src/3rdparty/qtsolutions/qtlocalpeer.cpp
	src/3rdparty/qtwin/qtwin.cpp
	src/aboutinfo.cpp
	src/abstractcontextlayer.cpp
	src/abstractlayer.cpp
	src/accountmanagement.cpp
	src/addaccountwizard.cpp
	src/console.cpp
	src/globalsettings/abstractglobalsettings.cpp
	src/globalsettings/globalproxysettings.cpp
	src/guisettingswindow.cpp
	src/iconmanager.cpp
	src/idle/idle.cpp
	src/idle/idle_mac.cpp
	src/idle/idle_win.cpp
	src/idle/idle_x11.cpp
	src/logindialog.cpp
	src/mainsettings.cpp
	src/pluginsettings.cpp
	src/pluginsystem.cpp
	src/profilelogindialog.cpp
	src/proxyfactory.cpp
	src/qutim.cpp
	src/qutimsettings.cpp
	src/systeminfo.cpp
	)

SET (RESOURCES
	qutim.qrc
	)

SET (FORMS
	src/aboutinfo.ui
	src/accountmanagement.ui
	src/console.ui
	src/globalsettings/globalproxysettings.ui
	src/guisettingswindow.ui
	src/logindialog.ui
	src/mainsettings.ui
	src/pluginsettings.ui
	src/profilelogindialog.ui
	src/qutim.ui
	src/qutimsettings.ui
	)

IF(NOT NO_ANTISPAM)
	LIST (APPEND HEADERS
		src/corelayers/antispam/abstractantispamlayer.h
		src/corelayers/antispam/antispamlayersettings.h
		)
	LIST (APPEND SOURCES
		src/corelayers/antispam/abstractantispamlayer.cpp
		src/corelayers/antispam/antispamlayersettings.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/antispam/antispamlayersettings.ui
		)
ELSE(NOT NO_ANTISPAM)
	ADD_DEFINITIONS( -DNO_CORE_ANTISPAM )
ENDIF(NOT NO_ANTISPAM)
IF(NOT NO_CHAT)
	LIST (APPEND HEADERS
		src/corelayers/chat/chatemoticonmenu.h
		src/corelayers/chat/chatforms/chatwindow.h
		src/corelayers/chat/chatforms/conferencewindow.h
		src/corelayers/chat/chatlayerclass.h
		src/corelayers/chat/chatwindowstyle.h
		src/corelayers/chat/chatwindowstyleoutput.h
		src/corelayers/chat/confcontactlist.h
		src/corelayers/chat/conferenceitem.h
		src/corelayers/chat/conferenceitemmodel.h
		src/corelayers/chat/conferencetabcompletion.h
		src/corelayers/chat/generalwindow.h
		src/corelayers/chat/logscity.h
		src/corelayers/chat/movielabel.h
		src/corelayers/chat/separatechats.h
		src/corelayers/chat/settings/chatlayersettings.h
		src/corelayers/chat/tabbedchats.h
		src/corelayers/chat/tempglobalinstance.h
		)
	LIST (APPEND SOURCES
		src/corelayers/chat/chatemoticonmenu.cpp
		src/corelayers/chat/chatforms/chatwindow.cpp
		src/corelayers/chat/chatforms/conferencewindow.cpp
		src/corelayers/chat/chatlayerclass.cpp
		src/corelayers/chat/chatwindowstyle.cpp
		src/corelayers/chat/chatwindowstyleoutput.cpp
		src/corelayers/chat/confcontactlist.cpp
		src/corelayers/chat/conferenceitem.cpp
		src/corelayers/chat/conferenceitemmodel.cpp
		src/corelayers/chat/conferencetabcompletion.cpp
		src/corelayers/chat/generalwindow.cpp
		src/corelayers/chat/logscity.cpp
		src/corelayers/chat/movielabel.cpp
		src/corelayers/chat/separatechats.cpp
		src/corelayers/chat/settings/chatlayersettings.cpp
		src/corelayers/chat/tabbedchats.cpp
		src/corelayers/chat/tempglobalinstance.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/chat/chatforms/chatform.ui
		src/corelayers/chat/chatforms/conferenceform.ui
		src/corelayers/chat/settings/chatlayersettings.ui
		)
ELSE(NOT NO_CHAT)
	ADD_DEFINITIONS( -DNO_CORE_CHAT )
ENDIF(NOT NO_CHAT)
IF(NOT NO_CONTACTLIST)
	LIST (APPEND HEADERS
		src/corelayers/contactlist/contactlistitemdelegate.h
		src/corelayers/contactlist/contactlistproxymodel.h
		src/corelayers/contactlist/contactlistsettings.h
		src/corelayers/contactlist/defaultcontactlist.h
		src/corelayers/contactlist/proxymodelitem.h
		src/corelayers/contactlist/treecontactlistmodel.h
		src/corelayers/contactlist/treeitem.h
		)
	LIST (APPEND SOURCES
		src/corelayers/contactlist/contactlistitemdelegate.cpp
		src/corelayers/contactlist/contactlistproxymodel.cpp
		src/corelayers/contactlist/contactlistsettings.cpp
		src/corelayers/contactlist/defaultcontactlist.cpp
		src/corelayers/contactlist/proxymodelitem.cpp
		src/corelayers/contactlist/treecontactlistmodel.cpp
		src/corelayers/contactlist/treeitem.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/contactlist/contactlistsettings.ui
		src/corelayers/contactlist/defaultcontactlist.ui
		)
ELSE(NOT NO_CONTACTLIST)
	IF(NOT NO_CHAT)
		LIST (APPEND HEADERS src/corelayers/contactlist/contactlistitemdelegate.h)
		LIST (APPEND SOURCES src/corelayers/contactlist/contactlistitemdelegate.cpp)
	ENDIF(NOT NO_CHAT)
	ADD_DEFINITIONS( -DNO_CORE_CONTACTLIST )
ENDIF(NOT NO_CONTACTLIST)
IF(NOT NO_EMOTICONS)
	LIST (APPEND HEADERS
		src/corelayers/emoticons/abstractemoticonslayer.h
		)
	LIST (APPEND SOURCES
		src/corelayers/emoticons/abstractemoticonslayer.cpp
		)
ELSE(NOT NO_EMOTICONS)
	ADD_DEFINITIONS( -DNO_CORE_EMOTICONS )
ENDIF(NOT NO_EMOTICONS)
IF(NOT NO_HISTORY)
	LIST (APPEND HEADERS
		src/corelayers/history/historysettings.h
		src/corelayers/history/historywindow.h
		src/corelayers/history/jsonengine.h
		src/corelayers/history/k8json.h
		)
	LIST (APPEND SOURCES
		src/corelayers/history/historysettings.cpp
		src/corelayers/history/historywindow.cpp
		src/corelayers/history/jsonengine.cpp
		src/corelayers/history/k8json.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/history/historysettings.ui
		src/corelayers/history/historywindow.ui
		)
ELSE(NOT NO_HISTORY)
	ADD_DEFINITIONS( -DNO_CORE_HISTORY )
ENDIF(NOT NO_HISTORY)
IF(NOT NO_NOTIFICATION)
	LIST (APPEND HEADERS
		src/corelayers/notification/defaultnotificationlayer.h
		src/corelayers/notification/notificationslayersettings.h
		src/corelayers/notification/popuptextbrowser.h
		src/corelayers/notification/popupwindow.h
		src/corelayers/notification/soundlayersettings.h
		)
	LIST (APPEND SOURCES
		src/corelayers/notification/defaultnotificationlayer.cpp
		src/corelayers/notification/notificationslayersettings.cpp
		src/corelayers/notification/popuptextbrowser.cpp
		src/corelayers/notification/popupwindow.cpp
		src/corelayers/notification/soundlayersettings.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/notification/notificationslayersettings.ui
		src/corelayers/notification/popupwindow.ui
		src/corelayers/notification/soundlayersettings.ui
		)
ELSE(NOT NO_NOTIFICATION)
	ADD_DEFINITIONS( -DNO_CORE_NOTIFICATION )
ENDIF(NOT NO_NOTIFICATION)
IF(NOT NO_SETTINGS)
	LIST (APPEND HEADERS
		src/corelayers/settings/qsettingslayer.h
		)
	LIST (APPEND SOURCES
		src/corelayers/settings/qsettingslayer.cpp
		)
ELSE(NOT NO_SETTINGS)
	ADD_DEFINITIONS( -DNO_CORE_SETTINGS )
ENDIF(NOT NO_SETTINGS)
IF(NOT NO_SOUNDENGINE)
	LIST (APPEND HEADERS
		src/corelayers/soundengine/defaultsoundenginelayer.h
		src/corelayers/soundengine/soundenginesettings.h
		)
	LIST (APPEND SOURCES
		src/corelayers/soundengine/defaultsoundenginelayer.cpp
		src/corelayers/soundengine/soundenginesettings.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/soundengine/soundenginesettings.ui
		)
ELSE(NOT NO_SOUNDENGINE)
	ADD_DEFINITIONS( -DNO_CORE_SOUNDENGINE )
ENDIF(NOT NO_SOUNDENGINE)
IF(NOT NO_SPELLER)
	LIST (APPEND HEADERS
		src/corelayers/speller/spellerhighlighter.h
		src/corelayers/speller/spellerlayerclass.h
		)
	LIST (APPEND SOURCES
		src/corelayers/speller/spellerhighlighter.cpp
		src/corelayers/speller/spellerlayerclass.cpp
		)
ELSE(NOT NO_SPELLER)
	ADD_DEFINITIONS( -DNO_CORE_SPELLER )
ENDIF(NOT NO_SPELLER)
IF(NOT NO_STATUS)
	LIST (APPEND HEADERS
		src/corelayers/status/defaultstatuslayer.h
		src/corelayers/status/statusdialog.h
		src/corelayers/status/statuspresetcaption.h
		)
	LIST (APPEND SOURCES
		src/corelayers/status/defaultstatuslayer.cpp
		src/corelayers/status/statusdialog.cpp
		src/corelayers/status/statuspresetcaption.cpp
		)
	LIST (APPEND FORMS
		src/corelayers/status/statusdialogvisual.ui
		src/corelayers/status/statuspresetcaption.ui
		)
ELSE(NOT NO_STATUS)
	ADD_DEFINITIONS( -DNO_CORE_STATUS )
ENDIF(NOT NO_STATUS)
IF(NOT NO_TRAY)
	LIST (APPEND HEADERS
		src/corelayers/tray/defaulttraylayer.h
		src/corelayers/tray/exsystrayicon.h
		)
	LIST (APPEND SOURCES
		src/corelayers/tray/defaulttraylayer.cpp
		src/corelayers/tray/exsystrayicon.cpp
		)
ELSE(NOT NO_TRAY)
	ADD_DEFINITIONS( -DNO_CORE_TRAY )
ENDIF(NOT NO_TRAY)

IF (WIN32)
#	LIST (APPEND SOURCES
#		src/ex/exsystrayicon.cpp
#		 src/idle/idle_win.cpp
#		)
#	LIST (APPEND HEADERS
#		src/ex/exsystrayicon.h
#		)
		
if (MINGW)
exec_program(windres
ARGS "-i qutim.rc -o qutim_res.o --include-dir=${CMAKE_CURRENT_SOURCE_DIR}")
LIST (APPEND SOURCES qutim_res.o)
else(MINGW)
LIST (APPEND SOURCES qutim.rc)
endif(MINGW)
 
ENDIF (WIN32)

#IF (APPLE)
#    LIST (APPEND SOURCES
#		src/ex/exsystrayicon.cpp
#	src/idle/idle_mac.cpp
#		)
#    LIST (APPEND HEADERS
#		src/ex/exsystrayicon.h
#		)
#	SET (MACOSX_BUNDLE_ICON_FILE icons/qutim.icns)
#
#ELSEIF (UNIX)
#	LIST (APPEND SOURCES
#		src/idle/idle_x11.cpp
#		)
#ENDIF ()


set( QUTIM_DO_NOT_FIND "true" )
include( FindQutIM )

=== plugins/jabber/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT (jabber)

LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

find_path(GLOOX_PATH "gloox" "${CMAKE_CURRENT_SOURCE_DIR}/libs")

file( GLOB_RECURSE QUTIM_H src/*.h include/*.h )
file( GLOB_RECURSE QUTIM_CPP src/*.cpp )
file( GLOB_RECURSE QUTIM_UI src/*.ui )

SET (JABBER_LIBS "")
SET (JABBER_INCLUDE_DIR "")

if( GLOOX_SHARED OR NOT GLOOX_PATH )
	SET( GLOOX_REQUIRED )
	include( FindGloox )
	if( GLOOX_FOUND )
		ADD_DEFINITIONS( -DHAVE_GLOOX )
		LIST(APPEND JABBER_LIBS ${GLOOX_LIBRARIES} )
		LIST(APPEND JABBER_INCLUDE_DIR ${GLOOX_INCLUDE_DIR})
		LIST(APPEND JABBER_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/" )
	endif( GLOOX_FOUND )
else( GLOOX_SHARED OR NOT GLOOX_PATH )
	LIST(REMOVE_ITEM QUTIM_H "${CMAKE_CURRENT_SOURCE_DIR}/src/gloox/dns.h")
	include( FindZLIB )
	include( FindLibIDN )
	if( OpenSSL )
		SET( OPENSSL_REQUIRED )
		include( FindOpenSSL )
	endif( OpenSSL )
	if( GNUTLS )
		SET( GNUTLS_REQUIRED )
		include( FindGNUTLS )
	endif( GNUTLS )
	if( WIN32  )
		FIND_LIBRARY( SECUR32_LIBRARIES secur32 )
		FIND_LIBRARY( CRYPT32_LIBRARIES crypt32 )
		if( SECUR32_LIBRARIES )
			message( STATUS "Secur32 found: ${SECUR32_LIBRARIES}" )
		else( )
			message( SEND_ERROR "Secur32 not found" )
		endif( )
		if( CRYPT32_LIBRARIES )
			message( STATUS "Crypt32 found: ${CRYPT32_LIBRARIES}" )
		else( )
			message( SEND_ERROR "Crypt32 not found" )
		endif( )
	endif( )
	file( GLOB GLOOX_CPP libs/gloox/*.cpp )
	file( GLOB GLOOX_H libs/gloox/*.h )

	if( GNUTLS_FOUND )
		ADD_DEFINITIONS ( -DHAVE_GNUTLS )
		LIST(APPEND JABBER_LIBS ${GNUTLS_LIBRARIES})
		LIST(APPEND JABBER_INCLUDE_DIR ${GNUTLS_INCLUDE_DIR})
	else( GNUTLS_FOUND )
		if( OPENSSL_FOUND )
			ADD_DEFINITIONS ( -DHAVE_OPENSSL )
			LIST(APPEND JABBER_LIBS ${OPENSSL_LIBRARIES} )
			if( WIN32 )
				LIST(APPEND JABBER_LIBS ${OPENSSL_EAY_LIBRARIES} )		
			endif( WIN32 )
			LIST(APPEND JABBER_INCLUDE_DIR ${OPENSSL_INCLUDE_DIR} )
		else( OPENSSL_FOUND )
			if( WIN32 )
				if( SECUR32_LIBRARIES AND CRYPT32_LIBRARIES )
					LIST(APPEND JABBER_LIBS ${SECUR32_LIBRARIES} )
					LIST(APPEND JABBER_LIBS ${CRYPT32_LIBRARIES} )
					ADD_DEFINITIONS ( -DHAVE_WINTLS )
				endif( SECUR32_LIBRARIES AND CRYPT32_LIBRARIES )
			endif( WIN32 )
		endif( OPENSSL_FOUND )
	endif( GNUTLS_FOUND )

	if( LIBIDN_FOUND )
		ADD_DEFINITIONS ( -DHAVE_LIBIDN )
		LIST(APPEND JABBER_LIBS ${LIBIDN_LIBRARIES} )
		LIST(APPEND JABBER_INCLUDE_DIR ${LIBIDN_INCLUDE_DIR} )
	endif( LIBIDN_FOUND )

	if( ZLIB_FOUND )
		ADD_DEFINITIONS ( -DHAVE_ZLIB )
		LIST(APPEND JABBER_LIBS ${ZLIB_LIBRARIES} )
		LIST(APPEND JABBER_INCLUDE_DIR ${ZLIB_INCLUDE_DIR} )
	endif( ZLIB_FOUND)
endif( GLOOX_SHARED OR NOT GLOOX_PATH )


include( CheckFunctionExists )

if( UNIX )
	FIND_LIBRARY( RESOLV_LIBRARIES resolv)
	if( RESOLV_LIBRARIES )
		ADD_DEFINITIONS ( -DHAVE_RES_QUERYDOMAIN )
		ADD_DEFINITIONS ( -DHAVE_DN_SKIPNAME )
		ADD_DEFINITIONS ( -DHAVE_RES_QUERY )
		LIST(APPEND JABBER_LIBS ${RESOLV_LIBRARIES})
		message( STATUS "Found resolv libs: ${RESOLV_LIBRARIES}" )
	else( )
		message( STATUS "Could NOT find resolv libs" )
	endif( RESOLV_LIBRARIES )
else( WIN32 )
	FIND_LIBRARY( DNSAPI_LIBRARIES dnsapi)
	FIND_PATH( WINDNS_H windns.h )
	if( DNSAPI_LIBRARIES AND WINDNS_H )
		ADD_DEFINITIONS ( -DHAVE_WINDNS_H )
		LIST(APPEND JABBER_LIBS ${DNSAPI_LIBRARIES})
	endif( DNSAPI_LIBRARIES AND WINDNS_H )
endif( )

check_function_exists( setsockopt SETSOCKOPT_EXISTS )
if( SETSOCKOPT_EXISTS )
	ADD_DEFINITIONS ( -DHAVE_SETSOCKOPT )
endif( SETSOCKOPT_EXISTS )

SET (QT_USE_QTNETWORK true)
SET (QT_USE_QTGUI true)
FIND_PACKAGE (Qt4 REQUIRED)

INCLUDE (${CMAKE_ROOT}/Modules/UseQt4.cmake)
FIND_PATH( QUTIM_INCLUDE_DIRS qutim/protocolinterface.h ../../include )
if( QUTIM_INCLUDE_DIRS )
	MESSAGE( STATUS "Found qutIM headers: ${QUTIM_INCLUDE_DIRS}" )
	INCLUDE_DIRECTORIES( ${QUTIM_INCLUDE_DIRS} )
else( QUTIM_INCLUDE_DIRS )
	MESSAGE( SEND_ERROR "Could NOT find qutIM development headers" )
endif( QUTIM_INCLUDE_DIRS )
if( APPLE )
	INCLUDE_DIRECTORIES ( /opt/local/include )
endif( APPLE )
#if( UNIX )
#INCLUDE_DIRECTORIES ( /usr/include )
#endif( UNIX )

INCLUDE_DIRECTORIES (${QT_QTGUI_INCLUDE_DIR}
	${QT_QTCORE_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${JABBER_INCLUDE_DIR}
	.
		src
		libs
	)

SET(HEADERS
${QUTIM_H}
${GLOOX_H}
libs/config.win.h
)

SET (SOURCES
${QUTIM_CPP}
${GLOOX_CPP}
)

SET (RESOURCES
./jabber.qrc
)

SET (FORMS
${QUTIM_UI}
)

QT4_WRAP_CPP (MOC_SRCS ${QUTIM_H})
QT4_WRAP_UI (UIS_H ${FORMS})
QT4_ADD_RESOURCES (RCC ${RESOURCES})

ADD_LIBRARY (jabber SHARED ${SOURCES} ${MOC_SRCS} ${UIS_H} ${RCC})

TARGET_LINK_LIBRARIES (jabber
	${QT_LIBRARIES}
	${JABBER_LIBS}
	)
# I do not think, that it is suitable for CMake.
#
# SET_TARGET_PROPERTIES(jabber
#   PROPERTIES
#   PREFIX "../lib"
# )

INSTALL (TARGETS jabber DESTINATION lib/qutim )

=== plugins/mrim/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT (mrim)

LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

file( GLOB_RECURSE MRIM_H coresrc/*.h uisrc/*.h)
file( GLOB_RECURSE MRIM_CPP coresrc/*.cpp uisrc/*.cpp)
file( GLOB_RECURSE MRIM_UI uisrc/*.ui)

# message( "MRIM C++ code: ${MRIM_CPP}" )
# message( "MRIM Headers: ${MRIM_H}" )

message( "INSTALL DIRECTORY: ${CMAKE_INSTALL_PREFIX} " )

include( CheckFunctionExists )

SET (MRIM_LIBS "")
SET (MRIM_INCLUDE_DIR "")

###For testing purposes, enable verbose logging in debug builds
IF (  CMAKE_BUILD_TYPE STREQUAL "Debug" )	
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG_LEVEL_DEV")
	MESSAGE( "Verbose logging enabled!" )
ENDIF ( CMAKE_BUILD_TYPE STREQUAL "Debug"  )
###

SET (QT_USE_QTNETWORK true)
SET (QT_USE_QTGUI true)
FIND_PACKAGE (Qt4 REQUIRED)
SET(QT_MIN_VERSION "4.4.0")

INCLUDE (${CMAKE_ROOT}/Modules/UseQt4.cmake)
FIND_PATH( QUTIM_INCLUDE_DIRS qutim/protocolinterface.h ../../include ../../../include)
if( QUTIM_INCLUDE_DIRS )
	MESSAGE( STATUS "Found qutIM headers: ${QUTIM_INCLUDE_DIRS}" )
	INCLUDE_DIRECTORIES( ${QUTIM_INCLUDE_DIRS} )
else( QUTIM_INCLUDE_DIRS )
	MESSAGE( SEND_ERROR "Could NOT find qutIM development headers" )
endif( QUTIM_INCLUDE_DIRS )
if( APPLE )
	INCLUDE_DIRECTORIES ( /opt/local/include )
endif( APPLE )
if( UNIX )
INCLUDE_DIRECTORIES ( /usr/include )
endif( UNIX )

INCLUDE_DIRECTORIES (${QT_QTGUI_INCLUDE_DIR}
        ${QT_QTCORE_INCLUDE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
	${MRIM_INCLUDE_DIR}
        .
                coresrc
                uisrc
        )

SET(HEADERS
${MRIM_H}
)

SET (SOURCES
${MRIM_CPP}
)

SET (RESOURCES
./mrim.qrc
)

SET (FORMS
${MRIM_UI}
)

QT4_WRAP_CPP (MOC_SRCS ${MRIM_H})
QT4_WRAP_UI (UIS_H ${FORMS})
QT4_ADD_RESOURCES (RCC ${RESOURCES})

ADD_LIBRARY (mrim SHARED ${SOURCES} ${MOC_SRCS} ${UIS_H} ${RCC})

TARGET_LINK_LIBRARIES (mrim
        ${QT_LIBRARIES}
        )

if ( !WIN32 )
INSTALL (TARGETS mrim DESTINATION lib/qutim )
endif ( !WIN32 )

if ( WIN32 )
INSTALL (TARGETS mrim DESTINATION ../qutim/lib/qutim )
endif ( WIN32 )

=== plugins/plugman/CMakeLists.txt ===
#Plugin manager
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT (plugman)

LIST (APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

SET (QT_USE_QTNETWORK true)
SET (QT_USE_QTGUI true)
SET (QT_USE_QTXML true)
FIND_PACKAGE (Qt4 REQUIRED)

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")


INCLUDE (${CMAKE_ROOT}/Modules/UseQt4.cmake)
FIND_PATH( QUTIM_INCLUDE_DIRS qutim/protocolinterface.h ../../include )
if( QUTIM_INCLUDE_DIRS )
	MESSAGE( STATUS "Found qutIM headers: ${QUTIM_INCLUDE_DIRS}" )
	INCLUDE_DIRECTORIES( ${QUTIM_INCLUDE_DIRS} )
else( QUTIM_INCLUDE_DIRS )
	MESSAGE( SEND_ERROR "Could NOT find qutIM development headers" )
endif( QUTIM_INCLUDE_DIRS )
if( APPLE )
	INCLUDE_DIRECTORIES ( /opt/local/include )
endif( APPLE )

include( FindZLIB )

if( ZLIB_FOUND )
        LIST(APPEND PLUGMAN_LIBS ${ZLIB_LIBRARIES} )
        LIST(APPEND PLUGMAN_INCLUDE_DIR ${ZLIB_INCLUDE_DIR} )
else( ZLIB_FOUND )
	MESSAGE( SEND_ERROR "Could NOT find zlib" )
endif( ZLIB_FOUND  )

INCLUDE_DIRECTORIES (${QT_INCLUDES}
    ${CMAKE_CURRENT_BINARY_DIR}
	${PLUGMAN_INCLUDE_DIR}
    .
		src
		libs
        )

SET (QT_HEADERS
	src/mirrorshandler.h
	src/utils/plugversion.h
	src/plugpackagehandler.h
	src/plugmanager.h
	src/plugitemdelegate.h
	src/collisionprotect.h
	src/plugman.h
	src/plugmansettings.h
	src/plugdownloader.h
	src/pluginstaller.h
	src/plugxmlhandler.h
	src/plugpackagemodel.h
	src/plugpackageitem.h
)
SET(HEADERS
${QT_HEADERS}
	src/mirror.h
	src/plugpackage.h
	libs/k8json/k8json.h
	src/hacks/plughacks.h
)

SET (SOURCES
	src/hacks/plughacks.cpp
	src/mirrorshandler.cpp
	src/utils/plugversion.cpp
	src/mirror.cpp
	src/plugpackagehandler.cpp
	src/plugmanager.cpp
	src/plugitemdelegate.cpp
	src/collisionprotect.cpp 
	src/plugxmlhandler.cpp
	src/plugman.cpp
	src/plugmansettings.cpp
	src/plugdownloader.cpp
	src/pluginstaller.cpp
	src/plugpackagemodel.cpp
	src/plugpackage.cpp
	src/plugpackageitem.cpp
	libs/k8json/k8json.cpp
)

SET (RESOURCES
	icons.qrc
)

SET (FORMS
	ui/settings.ui
	ui/manager.ui
)


add_subdirectory (libs)

IF (TOOLS)
	add_subdirectory (tools) #simple tools for maintaince
ENDIF (TOOLS)

QT4_WRAP_CPP (MOC_SRCS ${QT_HEADERS})
QT4_WRAP_UI (UIS_H ${FORMS})
QT4_ADD_RESOURCES (RCC ${RESOURCES})

ADD_LIBRARY (plugman SHARED ${SOURCES} ${MOC_SRCS} ${UIS_H} ${RCC})

TARGET_LINK_LIBRARIES (plugman
        ${QT_LIBRARIES}
        ${PLUGMAN_LIBS}
		qzipreader
        )

IF (TOOLS)
	ADD_LIBRARY (plugman_static STATIC ${SOURCES} ${MOC_SRCS} ${UIS_H} ${RCC})

	TARGET_LINK_LIBRARIES (plugman_static
        ${QT_LIBRARIES}
        ${PLUGMAN_LIBS}
 		qzipreader
        )
ENDIF (TOOLS)


INSTALL (TARGETS plugman DESTINATION lib/qutim )

=== plugins/plugman/libs/CMakeLists.txt ===
add_subdirectory (QZipReader)

=== plugins/plugman/tools/mirgen/CMakeLists.txt ===
PROJECT (mirgen)

SET (MIRGEN_SOURCES
	main.cpp
)

ADD_EXECUTABLE (mirgen  ${MIRGEN_SOURCES})

TARGET_LINK_LIBRARIES (mirgen
		${QT_LIBRARIES}
		${QZIPREADER_LIBS}
		qzipreader
		)

=== plugins/plugman/tools/packgen/CMakeLists.txt ===
PROJECT (packgen)

FIND_PACKAGE (Qt4 REQUIRED)

INCLUDE_DIRECTORIES (${QT_INCLUDES}
		${PLUGMAN_INCLUDE_DIR}
		${CMAKE_CURRENT_BINARY_DIR}
			.
		)


SET (PACKGEN_SOURCES
	main.cpp
    generatorwindow.cpp 
    pluglibinfo.cpp 
    choosecategorypage.cpp 
    choosepathpage.cpp 
    configpackagepage.cpp
)

SET (PACKGEN_HEADERS
	generatorwindow.h
    pluglibinfo.h
    choosecategorypage.h
    choosepathpage.h 
    configpackagepage.h
)

SET (FORMS
	choosecategorypage.ui 
    choosepathpage.ui 
    configpackagepage.ui
)

QT4_WRAP_CPP (MOC_SRCS ${PACKGEN_HEADERS})
QT4_WRAP_UI (UIS_H ${FORMS})


ADD_EXECUTABLE (packgen  ${PACKGEN_SOURCES} ${MOC_SRCS} ${UIS_H})


TARGET_LINK_LIBRARIES (packgen
		${QT_LIBRARIES}
		${QZIPREADER_LIBS}
		qzipreader
		plugman_static
		)

=== debian/changelog ===
qutim (0.2.0-0ubuntu9) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:41:38 +0000

qutim (0.2.0-0ubuntu8) utopic; urgency=high

  * No change rebuild against gnutls28.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 15 Aug 2014 23:10:12 +0100

qutim (0.2.0-0ubuntu7) quantal; urgency=low

  * debian/patches/include_uninstd:
    - Include unistd.h, fix FTBFS

 -- Angel Abad <angelabad@ubuntu.com>  Tue, 09 Oct 2012 13:40:08 +0200

qutim (0.2.0-0ubuntu6) maverick; urgency=low

  * Remove libqt4-webkit-dev from build-depends and add libqtwebkit-dev qtwebkit transition

 -- Kiszel Kristóf <ulysses@kubuntu.org>  Wed, 21 Jul 2010 13:03:56 +0200

qutim (0.2.0-0ubuntu5) maverick; urgency=low

  * debian/control: Add libqt4-webkit-dev t build-depends.

 -- Andreas Wenning <awen@awen.dk>  Mon, 24 May 2010 12:01:15 +0200

qutim (0.2.0-0ubuntu4) maverick; urgency=low

  * debian/control:
    - Build-depend on libgnutls-dev for Jabber GnuTLS support.
    - Bumped Standards-Version to 3.8.4.
  * debian/rules:
    - Enable GnuTLS build.
    - Remove execution rights from translation files (*.qm).

 -- Maia Kozheva <sikon@ubuntu.com>  Sat, 08 May 2010 13:35:21 +0700

qutim (0.2.0-0ubuntu3) lucid; urgency=low

  * debian/rules: Correctly install localization files. (LP: #535677)

 -- Maia Kozheva <sikon@ubuntu.com>  Sat, 27 Mar 2010 16:34:26 +0600

qutim (0.2.0-0ubuntu2) lucid; urgency=low

  * Migrated to 3.0 (quilt) source format.
  * debian/control, debian/rules:
    - Removed quilt references.

 -- Maia Kozheva <sikon@ubuntu.com>  Tue, 22 Dec 2009 14:41:41 +0600

qutim (0.2.0-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * debian/control:
    - Bumped Standards-Version.
    - Use debhelper 7.
    - Updated homepage and long description.
  * debian/copyright:
    - Updated homepage and upstream authors.
    - Fixed copyright symbol.
  * debian/compat:
    - Use 7.
  * debian/rules:
    - Shortened via dh 7. Project uses cmake now.
  * debian/qutim.desktop:
    - Deleted, use patched upstream file.
  * Install manpage via debian/manpages.

 -- Maia Kozheva <sikon@ubuntu.com>  Thu, 03 Dec 2009 15:09:01 +0600

qutim (0.1-0ubuntu1) intrepid; urgency=low

  [ Alexander Kopf ]
  * Initial release (LP: #240430)

  [ Harald Sitter ]
  * Replace build-conflict on qt3-dev-tools with usage of qmake-qt4
  * Add final full stop to long description

 -- Harald Sitter <apachelogger@ubuntu.com>  Wed, 18 Jun 2008 15:10:03 +0200

=== debian/control ===
Source: qutim
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexander Kopf <kopf-alexander@gmx.de>
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6), libqt4-dev (>= 4.4.0),
 libqtwebkit-dev, chrpath, zlib1g-dev, libidn11-dev, libgnutls-dev
Standards-Version: 3.8.4
Homepage: http://qutim.org

Package: qutim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: multi-protocol instant messenger
 qutIM is an open source, multi-protocol instant messaging client using the
 Qt 4 framework. It implements support for the ICQ, Jabber/XMPP/Google Talk,
 Mail.Ru Agent (MRIM), and IRC protocols, and is further extensible via
 plugins.

=== debian/rules ===
#!/usr/bin/make -f

DH            = dh --buildsystem=cmake
QMAKE_PLUGINS = histman icq irc vkontakte yandexnarod
CMAKE_PLUGINS = jabber mrim plugman

%:
	$(DH) $@

clean:
	$(DH) clean
	for dir in $(QMAKE_PLUGINS); do \
		[ ! -f plugins/$$dir/Makefile ] || $(MAKE) -C plugins/$$dir distclean; \
	done
	for dir in $(CMAKE_PLUGINS); do rm -rf plugins/$$dir/build; done

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_CXX_FLAGS="$(CFLAGS) -DQT_NO_DEBUG_OUTPUT"
	for dir in $(QMAKE_PLUGINS); do cd plugins/$$dir && qmake-qt4 && cd ../..; done
	for dir in $(CMAKE_PLUGINS); do \
		mkdir -p plugins/$$dir/build && \
		cd plugins/$$dir/build && \
		cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_CXX_FLAGS="$(CFLAGS) -fPIC" -DGNUTLS=1 && \
		cd ../../..; \
	done

override_dh_auto_build:
	dh_auto_build
	for dir in $(QMAKE_PLUGINS); do $(MAKE) -C plugins/$$dir; done
	for dir in $(CMAKE_PLUGINS); do $(MAKE) -C plugins/$$dir/build; done

override_dh_install:
	dh_install
	mkdir -p debian/qutim/usr/share/qutim/languages
	for x in bg_BG cs_CZ de_DE ru uk_UA ; do cp -R languages/$$x/binaries debian/qutim/usr/share/qutim/languages/$$x; done
	chmod 644 debian/qutim/usr/share/qutim/languages/uk_UA/*.qm
	chrpath -d debian/qutim/usr/bin/qutim debian/qutim/usr/lib/qutim/*
